# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc重置配货功能验证,32,32-26,sit,bs
主数据平台:后台运营系统重置配货接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_32st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_102")
password = commonFuc().get_business_data(module, "password_102")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步电商配货列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_dis")
request_body = commonFuc().get_business_data(module, "payload_dis")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 判断是否存在配货数据
if result["data"]["list"]:
    # 生成随机数
    super_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取配货信息信息
    distributionCode = result["data"]["list"][super_random]["distributionCode"]

    # 第三步进行配货重置操作
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url26")
    request_body = commonFuc().get_business_data(module, "payload26", distributionCode)

    """
     场景: 重置配货功能验证
     用例名称：重置配货功能验证
     输出：{"success":true,"code":"200","message":null,"data":null,"freshToken":null}
    """

    # 发送请求
    result = requests.get(url, params=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 将接口响应时间添加至result
    result = json.loads(result.content)
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict26")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)

