# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc展示最新修改信息_需求单详情_多采,33,33-45,sit,be
主数据平台:多采商城需求单详情接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import requests
import json

module = "cmdc_33st"

# 第一步登录多采商城获取token
username = commonFuc().get_business_data(module, "username_be")
password = commonFuc().get_business_data(module, "password_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步需求单创建
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_demand")
request_body = commonFuc().get_business_data(module, "payload_demand")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取需求单信息
demandId = result["data"]["国药集团联合医疗器械有限公司"]["demandItems"][0]["demandId"]
demandParentId = result["data"]["国药集团联合医疗器械有限公司"]["demandParentId"]
demandParentCode = result["data"]["国药集团联合医疗器械有限公司"]["demandParentCode"]
demandCode = result["data"]["国药集团联合医疗器械有限公司"]["demandItems"][0]["demandCode"]

# 第三步需求单修改操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_modify")
request_body = commonFuc().get_business_data(module, "payload_modify", demandId, demandParentId, demandParentCode,
                                             demandCode, demandCode)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 第四步获取需求单详情
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url45")
request_body = commonFuc().get_business_data(module, "payload45", demandParentCode, demandCode)
"""

 场景: 展示最新修改信息_需求单详情_多采
 用例名称：展示最新修改信息_需求单详情_多采
 输出：{"quantity":2.0000}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取需求单信息
result = json.loads(result.content)
# print(result)
result = {"quantity": result["data"]["demandHead"]["demandItems"][0]["quantity"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict45")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
