# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品不存在_批量新增商品包装,33,33-22,sit,be
主数据平台:后台运营系统商品包装批量新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os

module = "cmdc_33st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/商品包装管理新增模板_商品无效.xlsx"

# 第二步批量新增商品包装信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url22")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}
# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 第三步获取导入日志
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url10")
request_body = commonFuc().get_business_data(module, "payload10")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取导入日志信息
result = json.loads(result.content)
endUrl = result["data"]["list"][0]["endUrl"]

# 第四步获取日志说明
url = endUrl

"""
 场景:商品不存在_批量新增商品包装
 用例名称：商品不存在_批量新增商品包装
 输出：{"message":"商品编码不存在或已失效、未上架"}
"""

# 发送请求
result = requests.get(url, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/商品包装管理新增导入日志.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中商品包装信息
excel = HandleExcel(file_path, "Sheet1")
result = {"message": excel.read_data()[0].get("错误原因")}

# 将接口响应时间添加至result
result["api_time"] = api_time
file.close()

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict22")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

