# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc验证雅培选赠活动商品,2262,2262-15,sit,bs
涉及接口:运营后台管理系统登录、活动基本信息获取、活动包含的商品信息和查询商品对应的促销活动等接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json

module = "cmdc_commodity_activity"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username4")
password = commonFuc().get_business_data(module, "password4")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步进行促销活动列表获取
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload18")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取活动对应的activityBasicId和activityType
activity_basic_id = result["data"]["list"][0]["activityBasicId"]
activity_type = result["data"]["list"][0]["activityType"]

# 第三步获取雅培选赠活动对应的活动商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
# print(url)
request_body = commonFuc().get_business_data(module, "payload3", activity_basic_id, activity_type)
# print(request_body)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 获取活动用户companyCode、userId
company_code = result["data"][0]["companyCode"]
product_id = result["data"][0]["productId"]
product_code = result["data"][0]["productCode"]

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username3")
password = commonFuc().get_business_data(module, "password3")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第四步验证活动用户对应的活动
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
request_body = commonFuc().get_business_data(module, "payload21", company_code, product_id, product_code)

"""
 场景:登录活动用户账户、查看活动商品信息是否包含雅培选赠信息
 用例名称：特定用户特定商品雅培选赠活动验证
 输出：{"activityBasicId": "%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = result.elapsed.total_seconds()
result = json.loads(result.content)
# 获取活动客户对应的活动规则id
result = {"activityBasicId": result["data"][0]["activityBasicId"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict20", activity_basic_id)
print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
