# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc医院已存在_医院档案新增,2298,2298-36,sit,bs
主数据平台:后台运营系统医院档案新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_hospital"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取关联医院列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url9")
request_body = commonFuc().get_business_data(module, "payload9")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 获取随机数
hospital_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取医院信息
companyCode = result["data"]["list"][hospital_random]["companyCode"]
hospitalCode = result["data"]["list"][hospital_random]["hospitalCode"]
hospitalName = result["data"]["list"][hospital_random]["hospitalName"]
province = result["data"]["list"][hospital_random]["province"]
city = result["data"]["list"][hospital_random]["city"]
cityId = result["data"]["list"][hospital_random]["cityId"]
provinceId = result["data"]["list"][hospital_random]["provinceId"]

# 第三步进行医院档案新增
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url39")
request_body = commonFuc().get_business_data(module, "payload39", companyCode, hospitalCode, hospitalName, province,
                                             city, cityId, provinceId)

"""

 场景: 医院已存在_医院档案新增
 用例名称：医院已存在_医院档案新增
 输出：{"success":false,"code":"ERROR500","message":"当前医院名称已经存在","data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict39")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
