# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc宽限期编辑更新功能验证,2298,2298-27,sit,bs
主数据平台:后台运营系统宽限期编辑更新接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_hospital"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取宽限期管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url21")
request_body = commonFuc().get_business_data(module, "payload21")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
grace_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取宽限期信息
id = result["data"]["list"][grace_random]["id"]
productLineName = result["data"]["list"][grace_random]["productLineName"]
productLineCode = result["data"]["list"][grace_random]["productLineCode"]
graceMonth = result["data"]["list"][grace_random]["graceMonth"]
graceStage = result["data"]["list"][grace_random]["graceStage"]

# 第三步进行宽限期编辑更新操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url27")
request_body = commonFuc().get_business_data(module, "payload27", id, productLineName, productLineCode, graceMonth,
                                             graceStage)

"""

 场景: 宽限期编辑更新功能验证
 用例名称：宽限期编辑更新功能验证
 输出：{"success":true,"code":"200","message":"OK","data":"success","freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict27")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
