# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc导出功能验证_商品清单,2295,2295-91,sit,bs
主数据平台:后台运营系统获取客户商品列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import random
import os


module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取客户商品列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url87")
request_body = commonFuc().get_business_data(module, "payload87")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
product_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取商品信息
productInfo = result["data"]["list"][product_random]["productCode"]

# 第三步进行商品清单导出操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url91")
request_body = commonFuc().get_business_data(module, "payload91", productInfo)

"""

 场景: 导出功能验证_商品清单
 用例名称：导出功能验证_商品清单
 输出：{"productInfo":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/商品清单.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中商品编码
excel = HandleExcel(file_path, "Sheet1")
# print(excel.read_data())
result = {"productInfo": excel.read_data()[0].get("商品编码")}

# 将接口响应时间添加至结果中
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict91", productInfo)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
