# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc导出功能验证_终端流向,2295,2295-62,sit,bs
主数据平台:后台运营系统终端流向列表导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import random
import json
import os


module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取终端流向列表信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url60")
request_body = commonFuc().get_business_data(module, "payload60")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
flow_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取终端流向信息
demand_code = result["data"]["list"][flow_random]["demandCode"]

# 第三步进行导出操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url62")
request_body = commonFuc().get_business_data(module, "payload62", demand_code)
"""

 场景: 导出功能验证_终端流向
 用例名称：导出功能验证_终端流向
 输出：{"demandCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/终端流向管理列表.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中订单编号
excel = HandleExcel(file_path, "Sheet1")
# print(excel.read_data())
result = {"demandCode": excel.read_data()[0].get("订单编号")}

# 将接口响应时间添加至结果中
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict62", demand_code)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
