# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc收货地址批量导入空数据_代客下单,2295,2295-46,sit,bs
主数据平台:后台运营系统收货地址批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/批量导入收货地址模板.xlsx"

# 将收货地址写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=None)
excel.write_data(row=2, column=2, value=None)
excel.write_data(row=2, column=3, value=None)

# 第二步收货地址批量导入
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url45")
request_body = commonFuc().get_business_data(module, "payload45")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
 场景:收货地址批量导入空数据_代客下单
 用例名称：收货地址批量导入空数据_代客下单
 输出：{"success":false,"code":"5000070","message":"1,0,1","data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, files=files, headers=headers, data=request_body)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
# 将接口响应时间添加至result
result = json.loads(result.content)
# print(result)
result["api_time"] = api_time
file.close()

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict45")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
