# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_产品线管理,2293,2293-078,sit,bs
主数据平台:运营后台管理系统产品线列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_product"

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 获取产品线列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url71")
request_body = commonFuc().get_business_data(module, "payload71")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
line_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取产品线信息
product_line_code = result["data"]["list"][line_random]["productLineCode"]
product_line_name = result["data"]["list"][line_random]["productLineName"]

# 判断产品线是否分配制单员
if result["data"]["list"][line_random]["memberIdsList"]:
    # 产品线已分配制单员isDistribution为1
    is_distribution = 1
    # 获取制单员id
    member_id = result["data"]["list"][line_random]["memberIdsList"][0]
    # 进行查询条件验证
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url72")
    request_body = commonFuc().get_business_data(module, "payload72", product_line_code, product_line_name, member_id,
                                                 is_distribution)
    # print(request_body)
    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())
    result = json.loads(result.content)
    # print(result)
    # 获取查询结果中产品线信息
    result = {"productLineCode": result["data"]["list"][0]["productLineCode"]}
    result["api_time"] = api_time
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict72", product_line_code)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    # 产品线未分配制单员isDistribution为2
    is_distribution = 2
    # 制单员id不存在
    member_id = ""
    # 进行查询条件验证
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url72")
    request_body = commonFuc().get_business_data(module, "payload72", product_line_code, product_line_name, member_id,
                                                 is_distribution)
    # print(request_body)
    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())
    result = json.loads(result.content)
    # print(result)
    # 获取查询结果中产品线信息
    result = {"productLineCode": result["data"]["list"][0]["productLineCode"]}
    result["api_time"] = api_time
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict72", product_line_code)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)

"""
 场景: 查询条件验证_产品线管理
 用例名称：查询条件验证_产品线管理
 输出：{"productLineCode":"%s"}
"""

