# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取产品线商品信息,00,00-54,sit,be
主数据平台:后台运营系统获取产品线商品信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_special_version"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取植入列表产品线下拉列表数据
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31")
request_body = commonFuc().get_business_data(module, "payload31")
# 发送请求
result = requests.get(url, params=request_body)
result = json.loads(result.content)

# 生成随机数
line_random = random.randint(0, len(result["data"]) - 1)
# 获取产品线信息
productLineCode = result["data"][line_random]["productLineCode"]

# 第三步获取产品线商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url54")
request_body = commonFuc().get_business_data(module, "payload54", productLineCode)

"""

 场景: 获取产品线商品信息
 用例名称：获取产品线商品信息
 输出：{"productLineCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取产品线信息
result = json.loads(result.content)

# 判断产品线是否存在商品
if result["data"]:
    # 获取商品对应的产品线信息
    result = {"productLineCode": result["data"][0]["productLineCode"]}

    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict54", productLineCode)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    # 获取商品对应的产品线信息
    result = {"productLineCode": result["data"]}

    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict54_1")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
