# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc通过批次号获取上报数据验证,00,00-65,sit,be
主数据平台:后台运营系统通过批次号获取上报数据验证接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json

module = "cmdc_special_version"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_admin2")
password = commonFuc().get_business_data(module, "password_admin2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db_be")

# 在数据库中已存在且未被上报的生产批号信息
sql = "SELECT t.batchNumber,t.customerCode FROM `cmdc-order`.tc_report_batch t " \
      "WHERE deleteSign = 0 and batchNumber  in " \
      "(SELECT t1.batchNumber FROM `cmdc-order`.tc_report t1 where reportStatus = 101)"
batchNumber = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]
customerCode = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][1]

# 第二步通过批次号获取上报数据验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url65")
request_body = commonFuc().get_business_data(module, "payload65", batchNumber, customerCode)

"""

 场景: 通过批次号获取上报数据验证
 用例名称：通过批次号获取上报数据验证
 输出：{"batchNumber":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取上报数据
result = json.loads(result.content)
# print(result)
result = {"batchNumber": result["data"]["reportList"][0]["batchNumber"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict65", batchNumber)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

